package org.freehep.jas.extension.tupleExplorer.jel;

import gnu.jel.CompilationException;
import hep.aida.ref.tuple.FTuple;
import java.awt.Frame;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.event.DocumentListener;
import org.freehep.jas.extension.tupleExplorer.mutableTuple.MutableTuple;
import org.freehep.jas.extension.tupleExplorer.mutableTuple.MutableTupleTree;

/**
 *
 * @author  tonyj
 */
public class JELColumnProperties extends JDialog implements DocumentListener {
    
    private JELColumn column;
    private MutableTuple tuple;
    private MutableTupleTree tupleTree;

    /** Creates new form JELColumnProperties */
    public JELColumnProperties(Frame parent, JELColumn column, MutableTuple tuple, MutableTupleTree tupleTree) {
        super(parent, false);
        this.column = column;
        this.tuple = tuple;
        this.tupleTree = tupleTree;
        
        initComponents();
        expression.getDocument().addDocumentListener(this);
        doEnable();
        getRootPane().setDefaultButton(ok);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        ok = new javax.swing.JButton();
        cancel = new javax.swing.JButton();
        help = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        columnName = new javax.swing.JLabel();
        expression = new org.freehep.jas.extension.tupleExplorer.jel.ExpressionField(tuple, tupleTree);

        setTitle("Column Properties");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        ok.setMnemonic('O');
        ok.setText("OK");
        ok.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okActionPerformed(evt);
            }
        });

        jPanel1.add(ok);

        cancel.setMnemonic('C');
        cancel.setText("Cancel");
        cancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelActionPerformed(evt);
            }
        });

        jPanel1.add(cancel);

        help.setMnemonic('H');
        help.setText("Help");
        help.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                helpActionPerformed(evt);
            }
        });

        jPanel1.add(help);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanel2.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(10, 10, 10, 10)));
        columnName.setText(column.name()+"=");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        jPanel2.add(columnName, gridBagConstraints);

        expression.setEditable(false);
        expression.setText(column.getExpression());
        expression.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                expressionActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel2.add(expression, gridBagConstraints);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents
    
    private void expressionActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_expressionActionPerformed
    {//GEN-HEADEREND:event_expressionActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_expressionActionPerformed
    
    private void okActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_okActionPerformed
    {//GEN-HEADEREND:event_okActionPerformed
        try {
            NTupleCompiledExpression exp = expression.compile(null);
            //col.setExpression(expression.getText(),exp);
            dispose();
        }
        catch (CompilationException x) {
            String message = x.getMessage();
            JOptionPane.showMessageDialog(this,x,"Compilation Error",JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_okActionPerformed
    
    private void cancelActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cancelActionPerformed
    {//GEN-HEADEREND:event_cancelActionPerformed
        dispose();
    }//GEN-LAST:event_cancelActionPerformed
    
    private void helpActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_helpActionPerformed
    {//GEN-HEADEREND:event_helpActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_helpActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    public void removeUpdate(javax.swing.event.DocumentEvent documentEvent) {
        doEnable();
    }
    
    public void insertUpdate(javax.swing.event.DocumentEvent documentEvent) {
        doEnable();
    }
    
    public void changedUpdate(javax.swing.event.DocumentEvent documentEvent) {
        doEnable();
    }
    private void doEnable() {
        ok.setEnabled(!expression.getText().equals(column.getExpression()));
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancel;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JButton ok;
    private org.freehep.jas.extension.tupleExplorer.jel.ExpressionField expression;
    private javax.swing.JLabel columnName;
    private javax.swing.JButton help;
    // End of variables declaration//GEN-END:variables
    
}
